
/*
 * Structures for model: zener
 *
 * Automatically generated by cmpp preprocessor
 *
 * !!! DO NOT EDIT !!!
 *
 */


#include "ngspice/ngspice.h"
#include <stdio.h>
#include "ngspice/devdefs.h"
#include "ngspice/ifsim.h"
#include "ngspice/mifdefs.h"
#include "ngspice/mifproto.h"
#include "ngspice/mifparse.h"


static IFparm MIFmPTable[] = {
    IOP("v_breakdown", 0, IF_REAL, "breakdown voltage"),
    IOP("i_breakdown", 1, IF_REAL, "breakdown current"),
    IOP("r_breakdown", 2, IF_REAL, "breakdown resistance"),
    IOP("i_rev", 3, IF_REAL, "reverse current"),
    IOP("i_sat", 4, IF_REAL, "saturation current"),
    IOP("n_forward", 5, IF_REAL, "forward emission co"),
    IOP("limit_switch", 6, IF_FLAG, "switch for on-board limiting (convergence aid)"),
};


static IFparm MIFpTable[] = {
    OP("previous_voltage", 7, IF_STRING, "iteration holding variable for limiting"),
};


static Mif_Port_Type_t MIFportEnum0[] = {
    MIF_DIFF_CONDUCTANCE,
};


static char *MIFportStr0[] = {
    "gd",
};


static Mif_Conn_Info_t MIFconnTable[] = {
  {
    "z",
    "zener",
    MIF_INOUT,
    MIF_DIFF_CONDUCTANCE,
    "gd",
    1,
    MIFportEnum0,
    MIFportStr0,
    MIF_FALSE,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
  },
};

static union Mif_Parse_Value i_breakdown_default[] = {
    { .rvalue=2.000000e-02 },
};

static union Mif_Parse_Value r_breakdown_default[] = {
    { .rvalue=1.000000e+00 },
};

static union Mif_Parse_Value i_rev_default[] = {
    { .rvalue=1.000000e-06 },
};

static union Mif_Parse_Value i_sat_default[] = {
    { .rvalue=1.000000e-12 },
};

static union Mif_Parse_Value n_forward_default[] = {
    { .rvalue=1.000000e+00 },
};

static union Mif_Parse_Value limit_switch_default[] = {
    { .bvalue=MIF_FALSE },
};


static Mif_Param_Info_t MIFparamTable[] = {
  {
    "v_breakdown",
    "breakdown voltage",
    MIF_REAL,
    0,
    NULL,
    MIF_TRUE,
    { .rvalue=1.000000e-06 },
    MIF_TRUE,
    { .rvalue=1.000000e+06 },
    MIF_FALSE,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
  },
  {
    "i_breakdown",
    "breakdown current",
    MIF_REAL,
    1,
    i_breakdown_default,
    MIF_TRUE,
    { .rvalue=1.000000e-09 },
    MIF_FALSE,
    { .bvalue=MIF_FALSE },
    MIF_FALSE,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_TRUE,
  },
  {
    "r_breakdown",
    "breakdown resistance",
    MIF_REAL,
    1,
    r_breakdown_default,
    MIF_TRUE,
    { .rvalue=1.000000e-12 },
    MIF_FALSE,
    { .bvalue=MIF_FALSE },
    MIF_FALSE,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_TRUE,
  },
  {
    "i_rev",
    "reverse current",
    MIF_REAL,
    1,
    i_rev_default,
    MIF_TRUE,
    { .rvalue=1.000000e-09 },
    MIF_FALSE,
    { .bvalue=MIF_FALSE },
    MIF_FALSE,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_TRUE,
  },
  {
    "i_sat",
    "saturation current",
    MIF_REAL,
    1,
    i_sat_default,
    MIF_TRUE,
    { .rvalue=1.000000e-15 },
    MIF_FALSE,
    { .bvalue=MIF_FALSE },
    MIF_FALSE,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_TRUE,
  },
  {
    "n_forward",
    "forward emission co",
    MIF_REAL,
    1,
    n_forward_default,
    MIF_TRUE,
    { .rvalue=1.000000e-01 },
    MIF_TRUE,
    { .rvalue=1.000000e+01 },
    MIF_FALSE,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_TRUE,
  },
  {
    "limit_switch",
    "switch for on-board limiting (convergence aid)",
    MIF_BOOLEAN,
    1,
    limit_switch_default,
    MIF_FALSE,
    { .bvalue=MIF_FALSE },
    MIF_FALSE,
    { .bvalue=MIF_FALSE },
    MIF_FALSE,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_FALSE,
    0,
    MIF_TRUE,
  },
};


static Mif_Inst_Var_Info_t MIFinst_varTable[] = {
  {
    "previous_voltage",
    "iteration holding variable for limiting",
    MIF_STRING,
    MIF_FALSE,
  },
};


extern void cm_zener(Mif_Private_t *);

static int val_terms             = 0;
static int val_numNames          = 0;
static int val_numInstanceParms  = 1;
static int val_numModelParms     = 7;
static int val_sizeofMIFinstance = sizeof(MIFinstance);
static int val_sizeofMIFmodel    = sizeof(MIFmodel);

SPICEdev cm_zener_info = {
    .DEVpublic = {
        .name = "zener",
        .description = "zener diode",
        .terms = &val_terms,
        .numNames = &val_numNames,
        .termNames = NULL,
        .numInstanceParms = &val_numInstanceParms,
        .instanceParms = MIFpTable,
        .numModelParms = &val_numModelParms,
        .modelParms = MIFmPTable,
        .flags = 0,

        .cm_func = cm_zener,
        .num_conn = 1,
        .conn = MIFconnTable,
        .num_param = 7,
        .param = MIFparamTable,
        .num_inst_var = 1,
        .inst_var = MIFinst_varTable,
    },

    .DEVparam = NULL,
    .DEVmodParam = MIFmParam,
    .DEVload = MIFload,
    .DEVsetup = MIFsetup,
    .DEVunsetup = MIFunsetup,
    .DEVpzSetup = NULL,
    .DEVtemperature = NULL,
    .DEVtrunc = MIFtrunc,
    .DEVfindBranch = NULL,
    .DEVacLoad = MIFload,
    .DEVaccept = NULL,
    .DEVdestroy = NULL,
    .DEVmodDelete = MIFmDelete,
    .DEVdelete = MIFdelete,
    .DEVsetic = NULL,
    .DEVask = MIFask,
    .DEVmodAsk = MIFmAsk,
    .DEVpzLoad = NULL,
    .DEVconvTest = MIFconvTest,
    .DEVsenSetup = NULL,
    .DEVsenLoad = NULL,
    .DEVsenUpdate = NULL,
    .DEVsenAcLoad = NULL,
    .DEVsenPrint = NULL,
    .DEVsenTrunc = NULL,
    .DEVdisto = NULL,
    .DEVnoise = NULL,
    .DEVsoaCheck = NULL,
    .DEVinstSize = &val_sizeofMIFinstance,
    .DEVmodSize = &val_sizeofMIFmodel,

#ifdef CIDER
    .DEVdump = NULL,
    .DEVacct = NULL,
#endif

#ifdef KLU
    .DEVbindCSC = MIFbindCSC,
    .DEVbindCSCComplex = MIFbindCSCComplex,
    .DEVbindCSCComplexToReal = MIFbindCSCComplexToReal,
#endif
};

